# nettrans

 核心中的核心，如果你有一个自己的公网服务器。

## 1.介绍

利用某个IP作为中转服务器传输文件，服务器本身不存储文件仅中转，此IP可以是公网IP。

`核心想法：` 如果有自己的服务器时，不想下载网盘、微信、企鹅等需要登录的软件传输文件，可以用自己服务器作为中转（直接中转，而不是先放到服务器再下载，先放到服务器再下载对于频繁传输来说也有点麻烦）。

该工具使用为Qt客户端。

优势：

- 开源免费无广告。
- 体积大小固定、压缩包体积大致在20MB左右，不会像三方软件一直膨胀大小。
- 无需登录。
- 以文件夹形式管理传输文件。
- 跨平台。
- 干净整洁，没有三方软件安装后的七七八八的东西。

缺点： 

- 想公网传输需要有自己的公网IP。
- 中转的IP需要跑一个服务程序，一般如果有自己的服务器可以常驻运行。

## 2.与LocalSend的区别

||nettrans|localsend|
|-|-|-|
|传输|可局域可公网|只能局域网|
|服务程序|需要|不需要|
|客户端|仅三大平台(Linux、MacOS、Windows)|全平台|

主要点还是在公网访问。

## 3.与使用远程工具的区别

首先现在的远程工具也都得登录，其次就是经常遇到远程界面传输文件无法传输的问题，或者需要配置一些不知道在哪里配置的配置，网上各种找怎么配也麻烦，而且带画面会占用网络带宽，不带界面的文件传输路径查找麻烦。

`nettrans`仅需要配置一个服务器IP地址即可，无需其他额外配置。

## 4.与WebRTC区别

`WebRTC`技术也可以点点传输文件，但是感觉还是不太方便，如果仅仅是临时传输文件倒是可以一用，而且不清楚隐私问题怎么样。

`nettrans`使用你自己的服务器，文件传输隐私性要好一些。

## 3.应用场景

可能是我的需求都是工业工控机，这种机器一般没有外接口，或者外接口被占满，或者外接口不好够到（集成到各种设备中了）。

### 1.调试程序时

调试的程序开发机与运行机器不是同一个机器，现场也没有网线接口供直接链接机器，但是开发调试又需要不停的更新程序到客户机，
单纯使用U盘就很麻烦，如果此时客户机有外网访问，可以利用服务器中转直接对客户机文件进行替换修改。

### 2.临时传输文件

遇到一个场景，需要临时传输文件到一个PC机上，该PC机是工业工控机没有接口使用，联网也是使用的SIM卡，所有也没有局域网，想传输文件就需要下载QQ、微信什么的，如果不想下载这种需要登录的软件且保证PC机干净（很多软件安装后卸载卸载不彻底），可以使用`nettrans`，绿色免安装且仅有一个配置文件在用户目录下，不想用了界面提供删除配置文件功能。

### 3.局域网使用

有时候会有这样一种场景，客户机没有公网，且是Linux系统，如果使用远程桌面什么的需要安装工具（都需要网络），但是没有公网没法安装工具，而nettrans可以直接打包二进制文件，U盘丢到客户机就可以用局域网传输了（仅需配置IP地址)，主要在与方便，
